SystemOrganization addCategory: #DirtyExperiments!

PluggableListMorph subclass: #AutoSelectionList
	instanceVariableNames: 'originalList keystrokeMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DirtyExperiments'!

!AutoSelectionList methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 1/18/2011 15:28'!
basicKeyPressed: aChar 

	lastKeystrokes := lastKeystrokes, (aChar asString).
	self updateAfterKeyStroke.
	^ self getCurrentSelectionIndex! !

!AutoSelectionList methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 1/18/2011 17:13'!
changeModelSelection: anInteger
	"Change the model's selected item index to be anInteger."

	setIndexSelector ifNotNil:[ | currentElement index | 
		anInteger == 0
			ifTrue: [index := 0]
			ifFalse:[
				currentElement := list at: anInteger.
				index := originalList indexOf: currentElement].
		model perform: setIndexSelector with: index].! !

!AutoSelectionList methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 1/18/2011 15:47'!
displayKeyStrokeMorph
	| height center |
	
	center := 0.2.
	
	height := self keystrokeMorph minExtent y.
	self
		addMorph: self keystrokeMorph
		fullFrame:  ((0@0.8) corner: (1@1))
		
		
		"(LayoutFrame
			fractions: (center@1 corner: (1-center)@1)
			offsets:(0@0 corner:0@(height negative)))."! !

!AutoSelectionList methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 1/18/2011 17:12'!
getList
	"Answer the list to be displayed.  Caches the returned list in the 'list' ivar"
	| tempList |
	getListSelector == nil ifTrue: [^ #()].
	tempList := model perform: getListSelector.
	tempList ~= originalList
		ifTrue: [
			originalList := tempList.
			self resetLastKeyStrokes].
	originalList == nil ifTrue: [^ #()].
	tempList := originalList collect: [ :item | item asStringOrText ].
	((lastKeystrokes isNil) or: [lastKeystrokes isEmpty])
		ifTrue: [^list := tempList]
		ifFalse:[^list := tempList select: [:each | (each asLowercase) beginsWith: (lastKeystrokes asLowercase)]]! !

!AutoSelectionList methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 1/18/2011 15:43'!
initialize

	super initialize.
	self initializeKeyStrokeMorph! !

!AutoSelectionList methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 1/18/2011 15:43'!
initializeKeyStrokeMorph

	keystrokeMorph := LabelMorph new 
							getTextSelector: #lastKeyStrokes;
							enabled: false! !

!AutoSelectionList methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 1/18/2011 15:42'!
keystrokeMorph

	^ keystrokeMorph! !

!AutoSelectionList methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 1/18/2011 15:39'!
lastKeyStrokes

	^ lastKeystrokes! !

!AutoSelectionList methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 1/18/2011 17:08'!
resetLastKeyStrokes

	lastKeystrokes := ''! !

!AutoSelectionList methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 1/18/2011 17:13'!
selectionIndex: index
	"Called internally to select the index-th item."

	| row item idx |
	index == 0
		ifTrue: [idx := 0]
		ifFalse:[
			item := originalList at: index.
			idx := list indexOf: item].
	self unhighlightSelection.
	row := idx ifNil: [ 0 ].
	row := row min: self maximumSelection.  "make sure we don't select past the end"
	self listMorph selectedRow: row.
	self highlightSelection.
	self scrollSelectionIntoView.! !

!AutoSelectionList methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 1/18/2011 15:26'!
specialKeyPressed: asciiValue
	"A special key with the given ascii-value was pressed; dispatch it"

	| oldSelection nextSelection max howManyItemsShowing |

	asciiValue = 8 
		ifTrue: [ "backspace"
			((lastKeystrokes isNil) or: [lastKeystrokes isEmpty])
				ifTrue: [^self].
			lastKeystrokes := lastKeystrokes allButLast.
			self updateAfterKeyStroke].
		
	asciiValue = 27 ifTrue: 
		[" escape key"
		^ ActiveEvent shiftPressed
			ifTrue:
				[ActiveWorld invokeWorldMenuFromEscapeKey]
			ifFalse:
				[self yellowButtonActivity: false]].

	max := self maximumSelection.
	max > 0 ifFalse: [^ self].
	nextSelection := oldSelection := self getCurrentSelectionIndex.
	asciiValue = 31 ifTrue: 
		[" down arrow"
		nextSelection := oldSelection + 1.
		nextSelection > max ifTrue: [nextSelection := max]].
	asciiValue = 30 ifTrue: 
		[" up arrow"
		nextSelection := oldSelection - 1.
		nextSelection < 1 ifTrue: [nextSelection := 1]].
	asciiValue = 1 ifTrue:
		[" home"
		nextSelection := 1].
	asciiValue = 4 ifTrue:
		[" end"
		nextSelection := max].
	howManyItemsShowing := self numSelectionsInView.
	asciiValue = 11 ifTrue:
		[" page up"
		nextSelection := 1 max: oldSelection - howManyItemsShowing].
	asciiValue = 12 ifTrue:
		[" page down"
		nextSelection := oldSelection + howManyItemsShowing min: max].
	(self enabled and: [model okToChange]) ifFalse: [^ self].
	"No change if model is locked"
	oldSelection = nextSelection ifTrue: [^ self flash].
	^ self changeModelSelection: nextSelection! !

!AutoSelectionList methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 1/18/2011 17:15'!
updateAfterKeyStroke

	self changed: #lastKeyStrokes.
	self changeModelSelection: 0.
	self updateKeystrokeMorph.
	self displayKeyStrokeMorph.
	self updateList! !

!AutoSelectionList methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 1/18/2011 15:41'!
updateKeystrokeMorph

	self keystrokeMorph visible: (((self lastKeyStrokes isNil) or: [self lastKeyStrokes isEmpty]) not)! !

Object subclass: #DummyTest
	instanceVariableNames: 'list selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DirtyExperiments'!

!DummyTest classSide methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 1/18/2011 15:16'!
on: aList

	^ self new list: aList! !

!DummyTest methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 1/18/2011 15:15'!
addAll: aWindow

	aWindow
		addMorph: self buildAutoSelectionList
		frame: ((0.25@0) corner: (0.75@1))! !

!DummyTest methodsFor: 'building' stamp: 'BenjaminVanRyseghem 1/18/2011 15:34'!
buildAutoSelectionList

	^ AutoSelectionList
			on: self 
			list: #list 
			selected: #selection 
			changeSelected: #selection:! !

!DummyTest methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2011 15:12'!
list

	^list! !

!DummyTest methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2011 15:12'!
list: aList

	list := aList! !

!DummyTest methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 1/18/2011 15:13'!
openInWorld


	| window |
	window := StandardWindow new.
	self addAll: window.
	window openInWorld.
	window title: 'Dummy Example'! !

!DummyTest methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2011 15:20'!
selection
	
	selection ifNil: [selection := 0].
	^selection! !

!DummyTest methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2011 15:34'!
selection: aSelection

	selection := aSelection.
	self changed: #selection! !
